# $Id: test_approxDerivAt.py,v 1.1 2019/02/19 04:39:32 leavens Exp $
from math import isclose
from approxDerivAt import *

def test_approxDerivAt():
    """Testing for approxDerivAt."""
    eps = 1.0e-5
    # The functions used as the second argument are found below...
    assert isclose(approxDerivAt(1.0, id, 2.0, eps), 1.0, abs_tol=eps)
    assert isclose(approxDerivAt(1.0, id, 0.0, eps), 1.0, abs_tol=eps)
    assert isclose(approxDerivAt(4.0, linear, 0.0, eps), 1.0, abs_tol=eps)
    assert isclose(approxDerivAt(1.0, square, 3.0, eps), 6.0, abs_tol=eps)
    assert isclose(approxDerivAt(1.0, square, 5.0, eps), 10.0, abs_tol=eps)
    assert isclose(approxDerivAt(1.0, square, 0.25, eps), 0.5, abs_tol=eps)
    assert isclose(approxDerivAt(1.0, xp1TimesXm1, 5.0, eps), 10.0, abs_tol=eps)
    assert isclose(approxDerivAt(4.0, pow4, 10.0, eps), 20.0*10.0**3+6.0*10.0**2, abs_tol=eps)
    assert isclose(approxDerivAt(4.0, pow4, 2.0, eps), 20.0*2.0**3+6.0*2.0**2, abs_tol=eps)
    assert isclose(approxDerivAt(4.0, pow4, 2.0, 0.1), 20.0*2.0**3+6.0*2.0**2, abs_tol=0.1)
    assert isclose(approxDerivAt(1.0, pow4, 0.5, 0.1), 20.0*0.5**3+6.0*0.5**2, abs_tol=0.1)

# functions of type float -> float for use in testing
def id(x):
    return x

def linear(x):
    return x+2

def square(x):
    return x*x

def xp1TimesXm1(x):
    return x*x - 1

def pow4(x):
    return 5.0*x**4.0 + 2.0*x**3.0
