# $Id: test_graph.py,v 1.1 2019/02/19 03:14:23 leavens Exp $
from graph import graph
def test_graph():
    """Testing for graph."""
    # the functions used in this test are defined below...
    assert graph(plus1,[]) == []
    assert graph(plus1,[5, 10, 11, 9, 10]) \
        == [(5,6), (10,11), (11,12), (9,10), (10,11)]
    loi37420 = [3, 7, 4, 2, 0]
    assert graph(odd, loi37420) \
        == [(3,True), (7,True), (4,False), (2,False), (0,False)]
    # the argument is unchanged
    assert loi37420 == [3, 7, 4, 2, 0]
    assert graph(multBy3, list(range(6))) \
        == [(0,0), (1,3), (2,6), (3,9), (4,12), (5,15)]
    loi323000 = list(range(32,3000))
    gmb3big = graph(tnp1, loi323000)
    for i in loi323000:
        n = i-32
        assert gmb3big[n] == (i, tnp1(i))
    loi1100 = list(range(1,100))
    ghail = graph(hailstone, loi1100)
    for j in loi1100:
        m = j-1
        assert ghail[m] == (j, hailstone(j))

# some helping functions for testing
def plus1(n):
    return n+1

def multBy3(n):
    return n*3

def odd(n):
    return n % 2 == 1

def tnp1(n):
    if odd(n):
        return plus1(multBy3(n))
    else:
        return n

def hailstone(n):
    return tnp1(n) // 2
